/****************************************************************************
** CHRISTOPHER KRATZ - CS460 - TOS DATA ENGINE CLASS IMPLEMENTATION  **
****************************************************************************/

#include"DataServer.h"
#include<string.h>


cDataEngine::cDataEngine()
{
	//Code to load configuration should go here

	Queues = NULL;
	intQueueCnt = 0;
	
	/* This code is temporary for testing, eventually the system will load
		its configuration from a file dynamically			*/
	AddQueue("Agent1", SIZE_QUEUE);
	AddQueue("Agent2", SIZE_QUEUE);

}

cDataEngine::~cDataEngine()
{
	//Deconstructor
	
}


bool cDataEngine::AddQueue(char * name, int size)
{
	/*	This function adds a new queue to the Queues array.
		This would occur when adding a new client to the system, 
		probably during initializaton			*/
		
	cQueue * newQ = new cQueue(name, size);
	if(newQ == NULL) return false;
		
	int i;
	
	cQueue ** newQlist = new cQueue * [intQueueCnt + 1];
	if(newQlist == NULL) return false;
	

	for(i=0; i<intQueueCnt; i++)
	{
		newQlist[i] = Queues[i];
	}
	newQlist[i] = newQ;
	intQueueCnt++;
	
	delete[] Queues;
	Queues = newQlist;
	
	return true;
}

void cDataEngine::RemoveQueue(char * name)
{
	//Remove a queue from the system
}

void cDataEngine::LockQueue(char * name)
{
	//Locking to prevent multiple access
}

void cDataEngine::ReleaseQueue(char * name)
{
	//release a locked queue
}


int cDataEngine::GetMess(char * name, char * from, char * data,  int& length, int& ServiceNumber)
{
	/* Find the named queues index */
	int i;
	for(i = 0; i<intQueueCnt; i++)
	{
		if(strcmp(name, Queues[i]->name)==0)
		{
			break;
		}
	}
	int q = i;
	if(i==intQueueCnt)
	{
		return -2;
	}

	/* Get the next message off the queue */
	cMessage mess;
	if(Queues[q]->RemoveMessage(mess)==false)
	{
		/*Queue is empty*/
		return -1;
	}
	
	//data = new char[mess.intSize];
	
	/* Set return values */
	length =  mess.intSize;
		
	/* Copy data */
	for(i=0; i<length; i++)
	{
		data[i] = mess.data[i];
	}

	/* Free Memory */
	delete[] mess.data;

	/* Copy Destination */
	strncpy(from, mess.sender, SIZE_AGENTNAME);
	/* Free memory */
	delete[] mess.sender;

	/* Copy ServiceNumber */
	ServiceNumber = mess.ServiceNumber;

	/* Return the number of messages left in queue */
	return Queues[q]->getLength();
	
}

bool cDataEngine::PostMess(char * name, char * from, char * data,  int length, int ServiceNumber)
{
	/* Find the named queues index */
	int i;
	for(i = 0; i<intQueueCnt; i++)
	{
		if(strcmp(name, Queues[i]->name)==0)
		{
			break;
		}
	}
	int q=i;
	if(i==intQueueCnt)
	{
		return false;
	}
	/*---------------------------*/
	

	/* Create New Message */
	cMessage mess;
	mess.intSize = length;
	
	/* Allocate memory */
	mess.data = new char[length];
	/* Copy data into mess.data */
	for(i=0; i<length; i++)
	{
		mess.data[i] = data[i];
	}

	/* Allocate memory and copy from to mess.sender */
	mess.sender = new char[SIZE_AGENTNAME];
	strncpy(mess.sender, from, SIZE_AGENTNAME);

	/* Set Service Number */
	mess.ServiceNumber = ServiceNumber;
	
	/*Add The message */
	Queues[q]->AddMessage(mess);
	
	return true;
	
}


cQueue::cQueue(char * qname, int size)
{
	strcpy(name, qname);
	intSize = size;
	intFront = 0;
	intBack = 0;
	Messages = new cMessage[intSize];
	
}

cQueue::~cQueue()
{
	delete[] Messages;
}

int cQueue::getLength()
{
	if(intBack < intFront)
	{
		return intFront - intBack;
	}
	else if(intFront < intBack)
	{
		return (intSize - intBack) + intFront;
	}
	else
	{
		return 0;
	}

}

bool cQueue::AddMessage(cMessage mess)
{
	int old = intFront;
	
	intFront++;
	if(intFront==intSize)
	{
		intFront=0;
	}
	//Check queue for overflow
	if(intFront==intBack)
	{
		//Queue is full, drop message, 
		intFront = old;
		return false;
	}
	
	Messages[intFront] = mess;

	return true;
}

bool cQueue::RemoveMessage(cMessage& mess)
{
	
	if(intBack==intFront)
	{
		return false;
	}
	intBack++;
	if(intBack==intSize)
	{
		intBack=0;
	}

	mess = Messages[intBack];
	
	return true;
}
	
	
	


	