/* Kratz Multi-Process System Client APIs       */
/* These Api Functions will provide easy access */
/* To the functionality built into the          */
/* multi-process system server. Anyone wishing  */
/* to write a client for a system based on the  */
/* Multi-process system server is strongly      */
/* to use these API's                           */ 
/* ############################################ */
/*             :|         _____            |:   */
/*    -+------,____     ,"     ",          |:   */
/*   | |------|____\_  /  _    _ \         |:   */
/* ----|      |      \'  |#|  |#| ',       |:   */
/* ----|      |    () |  |#|  |#|  |       |:   */
/* ----|      |______/   |#|  |#|  |       |:   */
/*   | |      |       ".    __    ."       |:   */
/*   "-+------":|       \  |##|  /         |:   */
/*             :|        ".____."          |:   */
/*             :|                          |:   */
/* ############################################ */
/* This file is the headers and constants       */
/* Created: March 7, 2007 Christopher Kratz SNC */
/*                                              */
/* Modfication Log:                             */
/*                                              */
/* ############################################ */

/* CONSTANTS FOR USE WITH CLIENT FUNCTIONS */
const CLIENT_SIZE_BUFFER = 255;		/* Size to use for allocating general buffers */
const CLIENT_SIZE_MESSAGE = 255;	/* Size to use for messages */
const CLIENT_SIZE_PIPENAME = 255;	/* Max size of pipename buffer */
const CLIENT_SIZE_CLIENTNAME = 255;	/* Max size of clientname strings */


/* Given the name of the server pipe dedicated to you, established a connection */
HANDLE ConnectToServer(char * pipename);				

/* Given an open connection to the server, retrieves a single message from your */
/* messaging queue                                                              */
int GetMessageFromPeer(char * From,						/* From is filled with the name of the messages sender */
					   unsigned long& ServiceCode,		/* This returns the service code so the client can interpret the message*/
					   char * MessageData,				/* This is the actuall message data */
					   unsigned long& MessageLength,	/* this is the length of the message data */
					   HANDLE pipe);					/* Handle to open pipe */

/* This sends a message to another client in the system */
bool SendMessageToPeer(char * MessageData,			/* Data that you are sending */ 
					   unsigned long Length,		/* Length of the data that you are sending */
					   unsigned long ServiceCode,	/* Service Code for the data you are sending */
					   char * Destination,			/* Destination for your message */
					   HANDLE pipe);				/* Handle to open pipe */
