/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
///		CS460 - Christopher Kratz - Spring 2007                      ////
///                                                                  ////
///     Multi-Process Application Server                             ////
///                                                                  ////
///     Purpose:                                                     ////
///			This program serves as a central mechanism for processes////
///		in a multi-process application to communicate with each other////
///		and act as a single system.  This file contains the function ////
///     headers for main system functions.                           ////
///                                                                  ////
///		Modification Log:                                            ////
///			3-12-2007	C. Kratz	Created                          ////
///                                                                  ////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

const BUFFERSIZE = 255;		//Constant for size of general buffers
const RESPONSESIZE = 512;



struct WorkerThreadStartInfo							/* Struct to pass info to thread*/
{
	cDataEngine * data;		
	char ClientName[255];
	char PipeName[255];
};

void StartProcess(char * name,char * pipename);			//Executes a process


HANDLE StartWorkerThread(char * clientname,				//Begins the worker thread
						 char * pipename, 
						 cDataEngine * data);


unsigned int _stdcall WorkerThread(void * data);		//Worker thread


bool WaitForCommand(char * buffer, unsigned long& bytes, HANDLE pipe);	// Waits for a command to come in on the pipe
																		//	and reads it into buffer
	


bool ProcessCommand(		cDataEngine * data,				/* Pointer to the data class                    */
							char * clientname,				/* Name of client thread executing the command  */
							char * buffer,					/* buffer containing the command                */
							unsigned long bytes,			/* length of buffer data                        */
							char * response,				/* response to send back to client              */
							unsigned long& rbytes);			/* length of response                           */


bool SendResponse(			char * response,				/* The response to place on the pipe */	
							unsigned long rbytes,			/* The length of the response        */
							HANDLE pipe);					/* Handle to the pipe                */


void PostMessageToQueue	(	cDataEngine * data,				/* Pointer to the data class                    */
							char * clientname,				/* Name of client thread executing the command  */
							char * buffer,					/* buffer containing the command                */
							unsigned long bytes,			/* length of buffer data                        */
							char * response,				/* response to send back to client              */
							unsigned long& rbytes);			/* length of response                           */


void GetMessageFromQueue(	cDataEngine * data,				/* Pointer to the data class                    */
							char * clientname,				/* Name of client thread executing the command  */
							char * buffer,					/* buffer containing the command                */
							unsigned long bytes,			/* length of buffer data                        */
							char * response,				/* response to send back to client              */
							unsigned long& rbytes);			/* length of response                           */


void PostMulticastMessageToQueue(	cDataEngine * data,				/* Pointer to the data class                    */
									char * clientname,				/* Name of client thread executing the command  */
									char * buffer,					/* buffer containing the command                */
									unsigned long bytes,			/* length of buffer data                        */
									char * response,				/* response to send back to client              */
									unsigned long& rbytes);			/* length of response                           */


void AddNewRow(cDataEngine * data,
			   char * clientname,
			   char * buffer,
			   unsigned long bytes,
			   char * response, 
			   unsigned long rbytes);

void GetSchema(cDataEngine * data,
			   char * clientname,
			   char * buffer,
			   unsigned long bytes,
			   char * response, 
			   unsigned long rbytes);


void FindRows(cDataEngine * data,
			   char * clientname,
			   char * buffer,
			   unsigned long bytes,
			   char * response, 
			   unsigned long rbytes);

void DeleteRows(cDataEngine * data,
			   char * clientname,
			   char * buffer,
			   unsigned long bytes,
			   char * response, 
			   unsigned long rbytes);


/*####################################################################################*/
/*                                                                                    */
/*    %%%%  %%%%   %%%%%%%    %%%%%%%%%  %%%%%%%%%  %%%%%%%%%                         */
/*    %%%%  %%%%   %%%%%%%%   %%%   %%%  %%%%%%%%%  %%%%%%%%%                         */
/*   %%%%%%%%     %%%%  %%%  %%%%%%%%%     %%%        %%%%%                           */
/*   %%%%%%%%     %%%%%%%%   %%%%%%%%%     %%%      %%%%                              */
/*  %%%%  %%%%   %%%% %%%   %%%   %%%     %%%     %%%%%%%%%                           */
/*  %%%%  %%%%   %%%  %%%%  %%%   %%%     %%%     %%%%%%%%%                           */
/*                                                                                    */
/*      #######   ####    ####    ########       ****     ***     ***    ******       */
/*     #########  #####   ####   ##########     ******   *****   *****   *******      */
/*    ####        ######  ####  ####    ###          *  **   ** **   **       **      */
/*    ####        ######  ####  ####               **   **   ** **   **      **       */
/*     #######    ####### ####  ####              **    **   ** **   **     **        */
/*      #######   ############  ####            ******   *****   *****     **         */
/*          ####  #### #######  ####            ******    ***     ***     **          */
/*          ####  ####  ######  ####    ###                                           */
/*    #########   ####   #####   ##########      -- ---  !  ! !    +--+               */
/*     #######    ####    ####    ########      |   ",   +--! !--+ |  |               */
/*                                               -- --"     ! !__! +--+               */
/*####################################################################################*/

